Loading...
Searching...
No Matches
dolfin::MultiStageScheme Class Reference

Place-holder for forms and solutions for a multi-stage Butcher tableau based method. More...

`#include <MultiStageScheme.h>`

Inheritance diagram for dolfin::MultiStageScheme:
[legend]
Collaboration diagram for dolfin::MultiStageScheme:
[legend]

## Public Member Functions

MultiStageScheme (std::vector< std::vector< std::shared_ptr< const Form > > > stage_forms, std::shared_ptr< const Form > last_stage, std::vector< std::shared_ptr< Function > > stage_solutions, std::shared_ptr< Function > u, std::shared_ptr< Constant > t, std::shared_ptr< Constant > dt, std::vector< double > dt_stage_offset, std::vector< int > jacobian_indices, unsigned int order, const std::string name, const std::string human_form, std::vector< std::shared_ptr< const DirichletBC > > bcs={})

| Constructor.
std::vector< std::vector< std::shared_ptr< const Form > > > & | stage_forms ()
| Return the stages.
std::shared_ptr< const Form > | last_stage ()
| Return the last stage.
std::vector< std::shared_ptr< Function > > & | stage_solutions ()
| Return stage solutions.
std::shared_ptr< Function > | solution ()
| Return solution variable.
std::shared_ptr< const Function > | solution () const
| Return solution variable (const version).
std::shared_ptr< Constant > | t ()
| Return local time.
std::shared_ptr< Constant > | dt ()
| Return local timestep.
const std::vector< double > & | dt_stage_offset () const
| Return local timestep.
unsigned int | order () const
| Return the order of the scheme.
std::vector< std::shared_ptr< const DirichletBC > > | bcs () const
| Return boundary conditions.
bool | implicit (unsigned int stage) const
| Return true if stage is implicit.
bool | implicit () const
| Return true if the whole scheme is implicit.
int | jacobian_index (unsigned int stage) const
virtual std::string | str (bool verbose) const
| Return informal string representation (pretty-print).
Public Member Functions inherited from dolfin::Variable
| Variable ()
| Create unnamed variable.
| Variable (const std::string name, const std::string label)
| Create variable with given name and label.
| Variable (const Variable &variable)
| Copy constructor.
virtual | ~Variable ()
| Destructor.
const Variable & | operator= (const Variable &variable)
| Assignment operator.
void | rename (const std::string name, const std::string label)
| Rename variable.
std::string | name () const
| Return name.
std::string | label () const
| Return label (description).
std::size_t | id () const

## Additional Inherited Members

Public Attributes inherited from dolfin::Variable
Parameters | parameters
| Parameters.

## Detailed Description

Place-holder for forms and solutions for a multi-stage Butcher tableau based method.

## Member Function Documentation

## jacobian_index()

int MultiStageScheme::jacobian_index | ( | unsigned int | stage | ) | const

Return a distinct jacobian index for a given stage if negative the stage is explicit and hence no jacobian needed.

## str()

std::string MultiStageScheme::str | ( | bool | verbose | ) | const

virtual

Return informal string representation (pretty-print).

Reimplemented from dolfin::Variable.

The documentation for this class was generated from the following files:

- /build/dolfin-lFBzDh/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/multistage/MultiStageScheme.h
- /build/dolfin-lFBzDh/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/multistage/MultiStageScheme.cpp